unit CubicMisc;

interface

uses
    Windows, Messages, SysUtils, Classes, Contnrs, Controls, ExtCtrls;

//-----------------------------------------------------------------------------
//  c̃o[Ɉȉ̂悤ɔԍ
//
//    --2--
//  |       |
//  3       1
//  |       |
//    --0--
//  |       |
//  4       6
//  |       |
//    --5--
//
//  eo[`悷邩ǂ́ATag rbgtOƂ݂ȂƂ
//  eo[̔ԍɑΉrbg܂܂Ă邩ǂŔf
//
//  example) ... Number 3
//
//    --2--
//          |
//          1
//          |
//    --0--
//          |
//          6
//          |
//    --5--
//
//  87654321    rbgtǑʒu
//  *6543210    Ήo[̔ԍ
//  01111010    ON / OFF 

//-----------------------------------------------------------------------------
//  _(0,0)ƂƂ́Aeo[摜̏n߈ʒu
const
    BAR_TOPLEFT: array[0..6] of TPoint =
    (
        (X:  5; Y: 40), 
        (X: 40; Y:  5), 
        (X:  5; Y:  0), 
        (X:  0; Y:  5), 
        (X:  0; Y: 45), 
        (X:  5; Y: 80), 
        (X: 40; Y: 45)  
    );

//-----------------------------------------------------------------------------
//  _(0,0)ƂƂ́Ae摜̏n߈ʒu
const
    ARW_TOPLEFT: array[Boolean, 0..8] of TPoint =
    ((
        (X:  8; Y:  6),     //  E
        (X: 34; Y: 20),     //  E
        (X: 59; Y: 35),     //  E

        (X:  0; Y: 55),     //  
        (X:  0; Y: 84),     //  
        (X:  0; Y:112),     //  

        (X: 80; Y: 80),     //  
        (X:106; Y: 66),     //  
        (X:131; Y: 50)      //  
    ),(
        (X: 14; Y:  2),     //  
        (X: 40; Y: 16),     //  
        (X: 65; Y: 31),     //  

        (X:  0; Y: 52),     //  E
        (X:  0; Y: 81),     //  E
        (X:  0; Y:109),     //  E

        (X: 80; Y: 82),     //  
        (X:106; Y: 68),     //  
        (X:131; Y: 52)      //  
    ));

//-----------------------------------------------------------------------------
//  ɑΉtO

//    7  6  5  4 3 2 1 0
//  128 64 32 16 8 4 2 1

//-----------------------------------------------------------------------------
const
    FLG_ONE   = (1 shl 1) or (1 shl 6);
    FLG_EIGHT = $7F;

    FLG_NUMBER: array[0..10] of Byte =
    (
        FLG_EIGHT and (not (1 shl 0)),                      //  0
        FLG_ONE,                                            //  1
        FLG_EIGHT and (not (1 shl 3)) and (not (1 shl 6)),  //  2
        FLG_EIGHT and (not (1 shl 3)) and (not (1 shl 4)),  //  3
        FLG_ONE or (1 shl 0) or (1 shl 3),                  //  4
        FLG_EIGHT and (not (1 shl 1)) and (not (1 shl 4)),  //  5
        FLG_EIGHT and (not (1 shl 1)),                      //  6
        FLG_ONE or (1 shl 2),                               //  7
        FLG_EIGHT,                                          //  8
        FLG_EIGHT and (not (1 shl 4)) and (not (1 shl 5)),  //  9
        0                                                   //  NULL
    );

type
    TKillEraseBkGnd = class
    private
        FControl: TControl;
        FOrginalMethod: TWndMethod;
        procedure EmptyWmEraseBkGnd(var Msg: TMessage);
    public
        constructor Create(AControl: TControl);
        destructor Destroy(); override;
    end;

    TKillEraseBkGndFull = class
    private
        FList: TObjectList;
    public
        constructor Create();
        destructor Destroy(); override;
        procedure Kill(AOwner: TComponent);
    end;

var
    GKillEraseBkGndFull: TKillEraseBkGndFull = nil;

implementation

procedure TKillEraseBkGnd.EmptyWmEraseBkGnd(var Msg: TMessage);
begin
    if (Msg.Msg = WM_ERASEBKGND) then
    begin
        Msg.Result := 1;
    end
    else
    begin
        FOrginalMethod(Msg);
    end;
end;

constructor TKillEraseBkGnd.Create(AControl: TControl);
begin
    inherited Create();
    FControl := AControl;
    FOrginalMethod := FControl.WindowProc;
    FControl.WindowProc := EmptyWmEraseBkGnd;
end;

destructor TKillEraseBkGnd.Destroy();
begin
    FControl.WindowProc := FOrginalMethod;
    inherited Destroy();
end;

constructor TKillEraseBkGndFull.Create();
begin
    inherited Create();
    FList := TObjectList.Create(True);
end;

procedure TKillEraseBkGndFull.Kill(AOwner: TComponent);
var
    i: Integer;
    LComponent: TComponent;
    LControl: TControl;
begin
    FList.Create();
    for i := 0 to AOwner.ComponentCount - 1 do
    begin
        LComponent := AOwner.Components[i];
        if (LComponent.InheritsFrom(TControl)) then
        begin
            LControl := TControl(LComponent);
            FList.Add(TKillEraseBkGnd.Create(LControl));
        end;
        if (LComponent.InheritsFrom(TPaintBox)) then
        begin
            TPaintBox(LComponent).ControlStyle := TPaintBox(LComponent).ControlStyle + [csOpaque];
        end;
    end;
    if (AOwner.InheritsFrom(TControl)) then
    begin
        LControl := TControl(AOwner);
        FList.Add(TKillEraseBkGnd.Create(LControl));
    end;
end;

destructor TKillEraseBkGndFull.Destroy();
begin
    FList.Clear();
    FList.Free();
    inherited Destroy();
end;

initialization
    GKillEraseBkGndFull := TKillEraseBkGndFull.Create();
finalization
    GKillEraseBkGndFull.Free();
end.
