unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, CubicMisc;

//-----------------------------------------------------------------------------
//  tH[
type
  TForm1 = class(TForm)
    TimeCounter: TTimer;
    PnlDummy: TPanel;
    ImgHorBar: TImage;
    ImgVerBar: TImage;
    ImgHorBarDark: TImage;
    ImgVerBarDark: TImage;
    ImgDot: TImage;
    ImgDotDark: TImage;
    Pbox1000: TPaintBox;
    Pbox0100: TPaintBox;
    Pbox0010: TPaintBox;
    Pbox0001: TPaintBox;
    Pbox_100: TPaintBox;
    Pbox_010: TPaintBox;
    PboxDot: TPaintBox;
    LblUsage: TLabel;
    LblReady: TLabel;
    Label1: TLabel;
    procedure Pbox1000Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimeCounterTimer(Sender: TObject);
    procedure PboxDotPaint(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    BarImages: array[Boolean, 0..6] of TImage;
    procedure PowerOnTest();
    procedure ResetCounter();
    procedure SetCounter(const AValue: Double);

    procedure RepaintPaintBox(const ATag: Integer; const ARepaintAtOnce: Boolean;
                                const ADelay, ALastDelay: Integer);
  private

    FBeginTick: Cardinal;
    FEndTick: Cardinal;
    FCheckOk: Boolean;
    FCheckCancel: Boolean;

    FStartReady: Boolean;

  protected
    procedure WMNCHITTEST(var Msg: TWMNCHITTEST); message WM_NCHITTEST;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TForm1.FormCreate(Sender: TObject);
begin
    FCheckOk := False;
    FCheckCancel := False;
    FStartReady := False;

    //  wi
    Self.Color := clBlack;

    //  h~
    //GKillEraseBkGndFull.Kill(Self);
    Pbox_010.ControlStyle := Pbox_010.ControlStyle + [csOpaque];
    Pbox_100.ControlStyle := Pbox_100.ControlStyle + [csOpaque];
    Pbox0001.ControlStyle := Pbox0001.ControlStyle + [csOpaque];
    Pbox0010.ControlStyle := Pbox0010.ControlStyle + [csOpaque];
    Pbox0100.ControlStyle := Pbox0100.ControlStyle + [csOpaque];
    Pbox1000.ControlStyle := Pbox1000.ControlStyle + [csOpaque];
    PboxDot.ControlStyle := PboxDot.ControlStyle + [csOpaque];

    //  p摜z
    BarImages[True][0] := ImgHorBar;
    BarImages[True][1] := ImgVerBar;
    BarImages[True][2] := ImgHorBar;
    BarImages[True][3] := ImgVerBar;
    BarImages[True][4] := ImgVerBar;
    BarImages[True][5] := ImgHorBar;
    BarImages[True][6] := ImgVerBar;

    //  p摜z
    BarImages[False][0] := ImgHorBarDark;
    BarImages[False][1] := ImgVerBarDark;
    BarImages[False][2] := ImgHorBarDark;
    BarImages[False][3] := ImgVerBarDark;
    BarImages[False][4] := ImgVerBarDark;
    BarImages[False][5] := ImgHorBarDark;
    BarImages[False][6] := ImgVerBarDark;

    //  _͍ŏ͕`悵Ȃ
    PboxDot.Tag := -1;
end;

//-----------------------------------------------------------------------------
//  Borland - Delphi Q&A ^Cgo[NbNɃtH[hbOɂ
//  http://www.borland.co.jp/qanda/delphi/d0002348.html
procedure TForm1.WMNCHITTEST(var Msg: TWMNCHITTEST);
begin
    inherited;
    if Msg.Result = htClient then
    begin
        Msg.Result := htCaption;
    end;
end;

//-----------------------------------------------------------------------------
//  `(TagŐ)
procedure TForm1.Pbox1000Paint(Sender: TObject);
var
    LBuffer: TBitmap;
    LPaintBox: TPaintBox;
    LTag: Integer;
    i: Integer;
begin
    LPaintBox := TPaintBox(Sender);
    LTag := LPaintBox.Tag;

    LBuffer := nil;
    try
        LBuffer := TBitmap.Create();
        LBuffer.Width := LPaintBox.Width;
        LBuffer.Height := LPaintBox.Height;

        //  hԂ
        LBuffer.Canvas.Brush.Color := Self.Color;
        LBuffer.Canvas.FillRect(LPaintBox.ClientRect);

        //  o[`
        for i := 0 to 6 do
        begin
            LBuffer.Canvas.Draw(
                    BAR_TOPLEFT[i].X,
                    BAR_TOPLEFT[i].Y,
                    BarImages[(LTag and (1 shl i) <> 0)][i].Picture.Bitmap
                    );
        end;

        BitBlt(LPaintBox.Canvas.Handle, 0, 0, LPaintBox.Width, LPaintBox.Height,
            LBuffer.Canvas.Handle, 0, 0, SRCCOPY);
    finally
        LBuffer.Free();
    end;
end;

//-----------------------------------------------------------------------------
//  _`(TagŐ)
procedure TForm1.PboxDotPaint(Sender: TObject);
var
    LBuffer: TBitmap;
    LPaintBox: TPaintBox;
    LTag: Integer;
begin
    LPaintBox := TPaintBox(Sender);
    LTag := LPaintBox.Tag;

    LBuffer := nil;
    try
        LBuffer := TBitmap.Create();
        LBuffer.Width := LPaintBox.Width;
        LBuffer.Height := LPaintBox.Height;

        //  hԂ
        LBuffer.Canvas.Brush.Color := Self.Color;
        LBuffer.Canvas.FillRect(LPaintBox.ClientRect);

        //  hbg`
        if (LTag < 0) then
            LBuffer.Canvas.Draw(0, 0, ImgDotDark.Picture.Bitmap)
        else
            LBuffer.Canvas.Draw(0, 0, ImgDot.Picture.Bitmap);

        BitBlt(LPaintBox.Canvas.Handle, 0, 0, LPaintBox.Width, LPaintBox.Height,
            LBuffer.Canvas.Handle, 0, 0, SRCCOPY);
    finally
        LBuffer.Free();
    end;
end;

//-----------------------------------------------------------------------------
//  [Zt`FbNp`v
procedure TForm1.RepaintPaintBox(const ATag: Integer; const ARepaintAtOnce: Boolean;
                            const ADelay, ALastDelay: Integer);
begin
    Pbox_010.Tag := ATag;
    if (not ARepaintAtOnce) then Pbox_010.Repaint();
    if (ADelay > 0) then Sleep(ADelay);

    Pbox_010.Tag := ATag;
    if (not ARepaintAtOnce) then Pbox_010.Repaint();
    if (ADelay > 0) then Sleep(ADelay);

    Pbox_100.Tag := ATag;
    if (not ARepaintAtOnce) then Pbox_100.Repaint();
    if (ADelay > 0) then Sleep(ADelay);

    Pbox0001.Tag := ATag;
    if (not ARepaintAtOnce) then Pbox0001.Repaint();
    if (ADelay > 0) then Sleep(ADelay);

    Pbox0010.Tag := ATag;
    if (not ARepaintAtOnce) then Pbox0010.Repaint();
    if (ADelay > 0) then Sleep(ADelay);

    Pbox0100.Tag := ATag;
    if (not ARepaintAtOnce) then Pbox0100.Repaint();
    if (ADelay > 0) then Sleep(ADelay);

    Pbox1000.Tag := ATag;
    if (not ARepaintAtOnce) then Pbox1000.Repaint();
    if (ALastDelay > 0) then Sleep(ALastDelay);

    if (ARepaintAtOnce) then
    begin
        Pbox_010.Repaint();
        Pbox_100.Repaint();
        Pbox0001.Repaint();
        Pbox0010.Repaint();
        Pbox0100.Repaint();
        Pbox1000.Repaint();
        PboxDot.Repaint();
    end;
end;

//-----------------------------------------------------------------------------
//  [Zt`FbN
procedure TForm1.PowerOnTest();
var
    i: Integer;
    LTag: Integer;
    LInterval: Integer;
begin
    PboxDot.Tag := -1;
    PboxDot.Repaint();

    LInterval := 50;

    //  E[珇ɍɌāu8v_
    LTag := FLG_NUMBER[8];
    RepaintPaintBox(LTag, False, LInterval, LInterval);

    //  LZ`FbN
    Application.ProcessMessages();
    if FCheckCancel then Exit;

    //  Sɏ
    LTag := FLG_NUMBER[10];
    RepaintPaintBox(LTag, True, 0, 0);

    //  E[珇ɍɌāu8v_
    LTag := FLG_NUMBER[8];
    RepaintPaintBox(LTag, False, LInterval, LInterval);

    //  LZ`FbN
    Application.ProcessMessages();
    if FCheckCancel then Exit;

    //  E[珇ɍɌāu9v_
    LTag := FLG_NUMBER[9];
    RepaintPaintBox(LTag, False, LInterval, 0);

    //  LZ`FbN
    Application.ProcessMessages();
    if FCheckCancel then Exit;

    //  E[珇ɍɌďĂ
    LTag := FLG_NUMBER[10];
    RepaintPaintBox(LTag, False, LInterval, 0);

    //  LZ`FbN
    Application.ProcessMessages();
    if FCheckCancel then Exit;

    //  E[珇ɍɌāAׂẴo[_
    for i := 0 to 6 do
    begin
        LTag := 1 shl i;
        RepaintPaintBox(LTag, False, LInterval, 0);
        if(i <> 6) then Sleep(LInterval);

        //  LZ`FbN
        Application.ProcessMessages();
        if FCheckCancel then Exit;
    end;

    //  E[珇ɍɌďĂ
    LTag := FLG_NUMBER[10];
    RepaintPaintBox(LTag, False, LInterval, 0);

    //  LZ`FbN
    Application.ProcessMessages();
    if FCheckCancel then Exit;

    //  E[珇ɍɌĂׂĂ̐eXg
    for i := 0 to 10 do
    begin
        LTag := FLG_NUMBER[i];
        RepaintPaintBox(LTag, False, LInterval, 0);
        if(i <> 10) then Sleep(LInterval);

        //  LZ`FbN
        Application.ProcessMessages();
        if FCheckCancel then Exit;
    end;

    //  E[珇ɍɌāAׂẴo[_
    for i := 0 to 6 do
    begin
        LTag := 1 shl i;
        RepaintPaintBox(LTag, False, LInterval, 0);
        if(i <> 6) then Sleep(LInterval);

        //  LZ`FbN
        Application.ProcessMessages();
        if FCheckCancel then Exit;
    end;

    //  Sɏ
    LTag := FLG_NUMBER[10];
    RepaintPaintBox(LTag, True, 0, 0);
end;

//-----------------------------------------------------------------------------
//  JE^Zbg(0.00 ɃZbg)
procedure TForm1.ResetCounter();
var
   LTag: Integer;
begin
    LTag := FLG_NUMBER[0];
    Pbox_010.Tag := LTag;
    Pbox_100.Tag := LTag;
    Pbox0001.Tag := LTag;

    LTag := FLG_NUMBER[10];
    Pbox0010.Tag := LTag;
    Pbox0100.Tag := LTag;
    Pbox1000.Tag := LTag;

    PboxDot.Tag := 0;

    FEndTick := FBeginTick;

    Pbox_010.Repaint();
    Pbox_100.Repaint();
    Pbox0001.Repaint();
    Pbox0010.Repaint();
    Pbox0100.Repaint();
    Pbox1000.Repaint();
    PboxDot.Repaint();
end;

//-----------------------------------------------------------------------------
//  JE^Zbg(wlɃZbg)
procedure TForm1.SetCounter(const AValue: Double);
var
    LIntValue: Integer;
    LDecValue: Integer;
begin
    //  
    LIntValue := Trunc(AValue);

    //  
    LDecValue := Trunc((AValue - LIntValue) * 100);

    //  1̈
    Pbox0001.Tag := FLG_NUMBER[LIntValue mod 10];

    if (AValue >= 10) then
    begin
        //  10̈
        LIntValue := LIntValue div 10;
        Pbox0010.Tag := FLG_NUMBER[LIntValue mod 10];

        if (AValue >= 100) then
        begin
            //  100̈
            LIntValue := LIntValue div 10;
            Pbox0100.Tag := FLG_NUMBER[LIntValue mod 10];

            if (AValue >= 1000) then
            begin
                //  1000̈
                LIntValue := LIntValue div 10;
                Pbox1000.Tag := FLG_NUMBER[LIntValue mod 10];
            end
            else
            begin
                Pbox1000.Tag := FLG_NUMBER[10];
            end;
        end
        else
        begin
            Pbox0100.Tag := FLG_NUMBER[10];
            Pbox1000.Tag := FLG_NUMBER[10];
        end;
    end
    else
    begin
        Pbox0010.Tag := FLG_NUMBER[10];
        Pbox0100.Tag := FLG_NUMBER[10];
        Pbox1000.Tag := FLG_NUMBER[10];
    end;

    //  2
    Pbox_010.Tag := FLG_NUMBER[LDecValue mod 10];

    //  1
    LDecValue := LDecValue div 10;
    Pbox_100.Tag := FLG_NUMBER[LDecValue mod 10];

    Pbox_010.Repaint();
    Pbox_100.Repaint();
    Pbox0001.Repaint();
    Pbox0010.Repaint();
    Pbox0100.Repaint();
    Pbox1000.Repaint();
    PboxDot.Repaint();
end;


//-----------------------------------------------------------------------------
procedure TForm1.TimeCounterTimer(Sender: TObject);
begin
    FEndTick := GetTickCount();
    SetCounter((FEndTick - FBeginTick) / 1000);
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormPaint(Sender: TObject);
begin
    Self.OnPaint := nil;
    Self.Repaint();
    PowerOnTest();
    ResetCounter();
    FCheckOk := True;
    LblUsage.Caption := 'PRESS [LEFT CTRL] + [RIGHT CTRL] TO START';
end;

//-----------------------------------------------------------------------------
//  JnEI
procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
    LKeyState: SHORT;
    RKeyState: SHORT;
begin
    if (Key = VK_ESCAPE) then
    begin
        Self.Close();
    end;

    //  Zt`FbNȂ
    if (FCheckOk) then
    begin
        //  JnȌꍇ
        if (not TimeCounter.Enabled) then
        begin
            //  Zbgς
            if (FBeginTick = FEndTick) then
            begin
                //  ĂĂق
                LKeyState := GetKeyState(VK_LCONTROL);
                RKeyState := GetKeyState(VK_RCONTROL);

                //if (FStartReady) and (LKeyState = 0) and (RKeyState = 0) then
                if (FStartReady) then
                begin

                    FStartReady := False;
                    ResetCounter();
                    FBeginTick := GetTickCount();
                    FEndTick := FBeginTick;
                    LblReady.Caption := 'GO !';
                    TimeCounter.Enabled := True;
                    LblUsage.Caption := 'PRESS [SPACE] TO FINISH';
                end;
            end
            //  ZbgĂȂ
            else
            begin
                //  Zbg
                if (Key = VK_SPACE) then
                begin
                    ResetCounter();
                    LblUsage.Caption := 'PRESS [LEFT CTRL] + [RIGHT CTRL] TO START';
                end;
            end;
        end
        //  Jn̏ꍇ
        else
        begin
            if (Key = VK_SPACE) then
            begin
                LblReady.Hide();
                LblReady.Caption := 'Ready';
                TimeCounter.Enabled := False;
                FEndTick := GetTickCount();
                SetCounter((FEndTick - FBeginTick) / 1000);
                LblUsage.Caption := 'PRESS [SPACE] TO RESET';
            end;
        end;
    end

    //  Zt`FbNȂ
    else
    begin
        //  LZ
        FCheckCancel := True;
    end;
end;

//-----------------------------------------------------------------------------
//  Jn
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
    LKeyState: SHORT;
    RKeyState: SHORT;
begin
    FStartReady := False;

    //  ẼRg[L[`FbN
    LKeyState := GetKeyState(VK_LCONTROL);
    RKeyState := GetKeyState(VK_RCONTROL);

    if (FBeginTick = FEndTick) then
    begin
        //  Jn
        FStartReady := (LKeyState < 0) and (RKeyState < 0);
        LblReady.Visible := FStartReady;
    end;
end;

end.
